# script1502.py - Record a Swallow Sighting
# Written by Blum and Bresnahan
#
############ Import Modules  ##################
#
# Birds object file
from birds import Bird
#
# Barn Swallow object file
from barnswallow import BarnSwallow
#
# South Africa Cliff Swallow object file
from sacliffswallow import SouthAfricaCliffSwallow
#
# Import Date Time function
import datetime
#
################################################
def main ():	#Mainline
	###### Create Variables & Object Instances ###
	#
	flock_size='0'	#Number of birds sighted
	sex='unknown'  	#Male, female, or unknown
	species=''	#Barn or Cliff Swallow Object
	#
	barn_swallow=BarnSwallow(sex,flock_size)
	sa_cliff_swallow=SouthAfricaCliffSwallow(sex,flock_size)
	#
	###### Instructions for Script User #########
	print()
	print("The following characteristics are listed")
	print("in order to help you determine what swallow")
	print("you have sighted.")
	print()
	#
	###### Show Barn Swallow Characterstics #####
	#
	print("A barn swallow is a bird that", end=' ')
	if barn_swallow.get_migratory() == 'yes':
    		print("is migratory.")
	else:
    		print("is not migratory.")
	#
	######## Show Cliff Swallow Characterstics ######
	#
	print("A cliff swallow is a bird that", end=' ')
	if sa_cliff_swallow.get_migratory() == 'yes':
    		print("is migratory.")
	else:
    		print("is not migratory.")
	#
	######## Obtain Swallow Sighted #################
	print()
	print("Which did you see?")
	print("European/Barn Swallow    - 1")
	print("African Cliff Swallow    - 2")
	species = input("Type number & press Enter: ")
	print()
	#
	######## Obtain Flock Size #################
	#
	flock_size=int(input("Approximately, how many did you see? "))
	#
	###### Mutate Sighted Birds' Flock Size ####
	#
	if species == '1':
		barn_swallow.set_flock_size(flock_size)
	else:
		sa_cliff_swallow.set_flock_size(flock_size)
	#
	###### Display Sighting Data ################
	print()
	print("Thank you.")
	print("The following data will be forwarded to")
	print("the Great Backyard Bird Count.")
	print("www.birdsource.org/gbbc")
	#
	print()
	print("Sighting on \t", datetime.date.today())
	if species == '1':
		print("Species: \t European/Barn Swallow")	
		print("Flock Size: \t", barn_swallow.get_flock_size())
		print("Sex: \t\t", barn_swallow.get_sex())
	else:
		print("Species: \t South Africa Cliff Swallow")	
		print("Flock Size: \t", sa_cliff_swallow.get_flock_size())
		print("Sex: \t\t", sa_cliff_swallow.get_sex())		
#
#########################################################
#
########## Call the main function #######################
main()
